' based on code from https://www.youtube.com/watch?v=ybLZyY655iY

clear all
background 135,206,235
locate 0,textrows-10
print "Use arrow keys to rotate and move forward/backward. Press Space to load a new map."
print
print "Use 'Q' and 'A' to change the NEAR argument."
print "Use 'W' and 'S' to change the FAR argument."
print "Use 'Z' and 'X' to change the FOVHALF argument."
print
print "Use 'R' to reset the NEAR, FAR, and FOVHALF arguments."
print
print "Press Esc to quit."
WIDTH=400:HEIGHT=250 'WIDTH=640:HEIGHT=400
BITMAP 1 LOAD "MarioKart-1.png"
BITMAP 2 NEW WIDTH,HEIGHT target
layer 1 use bitmap 2 show fill
r=1:d=1:n=1
do
  if r then
    worldX=1000.915
    worldY=1000.575
    worldA=4.700
    near=0.005
    far=0.020
    fovHalf=PI/4.0
    r=0
  end if
  if d then
    locate 0,0
    PRINT "worldx: ";using$("####.###",worldx),;
    PRINT "worldy: ";using$("####.###",worldy),;
    PRINT "worlda: ";using$("####.###",worlda),;
    PRINT "near: ";using$("####.###",near),;
    PRINT "far: ";using$("####.###",far),;
    PRINT "fovHalf: ";using$("####.###",fovHalf)
    blit frustum 1,worldX,worldY,worldA,near,far,fovHalf WINDOW 0,HEIGHT/3,WIDTH-1,HEIGHT-1
    d=0
  end if
  IF KEYpressed(vk_esc) THEN EXIT DO
  if keypressed(vk_space) then
    n=n+1:if n=4 then n=1
    BITMAP 1 LOAD "MarioKart-"+str$(n)+".png"
    d=1
  end if
  IF KEYDOWN(vk_left) THEN worldA=worldA-0.05:d=1
  IF KEYDOWN(vk_right) THEN worldA=worldA+0.05:d=1
  IF KEYDOWN(vk_up) THEN worldX=worldX+(COS(worldA)*0.005):worldY=worldY+(SIN(worldA)*0.005):d=1
  IF KEYDOWN(vk_down) THEN worldX=worldX-(COS(worldA)*0.005):worldY=worldY-(SIN(worldA)*0.005):d=1
  if keydown(asc("r")) then r=1:d=1
  IF KEYDOWN(ASC("q")) THEN near=near+0.01:d=1
  IF KEYDOWN(ASC("a")) THEN near=near-0.01:d=1
  IF KEYDOWN(ASC("w")) THEN far=far+0.01:d=1
  IF KEYDOWN(ASC("s")) THEN far=far-0.01:d=1
  IF KEYDOWN(ASC("z")) THEN fovHalf=fovHalf+0.01:d=1
  IF KEYDOWN(ASC("x")) THEN fovHalf=fovHalf-0.01:d=1
  PAUSE 0
LOOP
