CLEAR ALL
PRINT
PRINT "Press any key to see the next Bezier curve, or ESC to quit. Click on the nodes to change the Bezier curve."
bitmap 1 new 20,20 target
'rect fill 0,0,19,19
circle fill 10,10,9
sprite 1 use bitmap 1 show xystep 2,2 tint rgb(255,0,0)    ' red
sprite 2 use bitmap 1 show xystep 2,2 tint rgb(0,255,0)    ' green
sprite 3 use bitmap 1 show xystep 2,2 tint rgb(255,255,0)  ' yellow
sprite 4 use bitmap 1 show xystep 2,2 tint rgb(0,0,255)    ' blue
mode 5
dim x(4),y(4)
do
  for i=1 to 4
    x(i)=range(0,639):y(i)=range(0,399)
  next i
  gosub redraw
  for i=1 to 4
    sprite i move x(i),y(i)
  next i
  do
    for i=1 to 4
      if clicked(i) then
        x(i)=mousex/2:y(i)=mousey/2
        gosub redraw
        sprite i move x(i),y(i)
        exit for
      end if
    next i
    pause 0
    a$=inkey$
  loop while a$=""
LOOP UNTIL a$=CHR$(27)
end

redraw:
clear bitmap
bezier curve x(1),y(1),x(2),y(2),x(3),y(3),x(4),y(4)
return
